import csv
import codecs
from langdetect import detect




languages = {}
def languageDetection(tweets):
    englishTweets = []
    for i in range(len(tweets)):
        if len(tweets[i]) < 7:
            continue
        if len(tweets[i][5].strip()) < 1:
            englishTweets.append(tweets[i])
        try:
            lang = detect(preprocess(tweets[i][5]))
            if lang in languages.keys():
                languages[lang] += 1
            else:
                languages[lang] = 1
            if lang == 'en':
                englishTweets.append(tweets[i])
            else:
                nonEnglishTweets.append(tweets[i])
        except Exception as e:
            print(e)
            print('Tweet: ' + tweets[i][5])
    return englishTweets


def preprocess(text):
    newtext = text.replace('URL', '')
    newtext = newtext[:3].replace('rt ', '') + newtext[3:]
    newtext = newtext.replace('MENTION', '')
    return newtext


def loadDataset(filename):
    dataset = []
    #with open('data/' + filename + '.csv') as csv_file:
    csv_reader = csv.reader(codecs.open('data/' + filename + '.csv', 'rU', 'utf-8'), delimiter=',')
    for row in csv_reader:
        dataset.append(row)
    return dataset


def saveDataset(filename, dataset, mode='w'):
    with open('data/' + filename + '.csv', mode=mode, encoding='utf-8') as csv_file:
        csv_writer = csv.writer(csv_file, delimiter=',')
        for row in dataset:
            csv_writer.writerow(row)


# Disse to funksjonene lagrer og henter fra en txt fil hvor langt man er kommet
# i tilfelle noe blir avbrutt
def loadProgress():
    with open('preprocessingProgress.txt', 'r') as f:
        progress = f.read()
    f.close()
    return int(progress.strip())


def saveProgress(progress):
    with open('preprocessingProgress.txt', 'w') as f:
        f.write(str(progress))
    f.close()
    return True


# det mest preprosesserte datasetet (last ned fra drive)
data = loadDataset('nonEnglishTweets')


# Hvis koden blir avbrutt og må kjøres på nytt kommenteres den øverste linja
# ut og den nederste blir avkommentert så den starter opp der den var
startingPoint = 0
# startingPoint = loadProgress()

# setter opp non-english tom til å begynne med
nonEnglishTweets = []
# Kjører språkdeteksjon på en blokk med 30 000 tweets av gangen før den lagrer både dataen og fremgangen.
for i in range(startingPoint, len(data), 30000):
    print(i)
    # lagrer non-english hver 300 000
    if i % 300000 == 0:
        print("saving non-english")
        saveDataset('reallyNonEnglishTweets', nonEnglishTweets, 'a')
        nonEnglishTweets = []
    englishTweets = []
    englishTweets = languageDetection(data[i:i+30000])
    saveDataset('englishTweets_mention', englishTweets, 'a')
    saveProgress(i+30000)



