# -*- coding: utf-8 -*-
import re
import numpy as np
import nltk
import pandas as pd
from langdetect import detect
from nltk.corpus import stopwords
nltk.download('stopwords')


stop_words = set(stopwords.words('english'))


def preprocess(text):
    # lowercase
    text = ''.join(text).lower()
    # remove symbols
    text = ' '.join(re.split(r'\W+', text))
    #text = ' '.join([x for x in text.split() if x not in stop_words])
    return text


# setting them to 2, 4 as that is not totally extreme but more in line with the
#numericlabels = {'y': 4.0, 'n': 2.0}
# averagelabels based on twitter data
numericlabels_ext = {'y': avg_ext_y, 'n': avg_ext_n}
numericlabels_agr = {'y': avg_agr_y, 'n': avg_agr_n}
numericlabels_neu = {'y': avg_neu_y, 'n': avg_neu_n}
numericlabels_con = {'y': avg_con_y, 'n': avg_con_n}
numericlabels_opn = {'y': avg_opn_y, 'n': avg_opn_n}


essays_raw = pd.read_csv('essays2.csv', delimiter=',',quotechar='"')

# remove unneeded fields
essays_df = essays_raw[['TEXT', 'cEXT', 'cNEU', 'cAGR', 'cCON', 'cOPN']]

for index, row in essays_df.iterrows():
    row["TEXT"] = preprocess(row["TEXT"])
    row["cEXT"] = numericlabels_ext[row["cEXT"]]
    row["cNEU"] = numericlabels_agr[row["cNEU"]]
    row["cAGR"] = numericlabels_neu[row["cAGR"]]
    row["cCON"] = numericlabels_con[row["cCON"]]
    row["cOPN"] = numericlabels_opn[row["cOPN"]]


"""
for index, row in essays_df.iterrows():
    row["TEXT"] = preprocess(row["TEXT"])
    row["cEXT"] = numericlabels[row["cEXT"]]
    row["cNEU"] = numericlabels[row["cNEU"]]
    row["cAGR"] = numericlabels[row["cAGR"]]
    row["cCON"] = numericlabels[row["cCON"]]
    row["cOPN"] = numericlabels[row["cOPN"]]

"""

essays_df.columns = ['TEXT', 'sEXT', 'sNEU', 'sAGR', 'sCON', 'sOPN']

