import glob
import re
import numpy as np
import pandas as pd



def preprocess(text):
    text = ''.join(text).lower()
    text = text.replace("'", '')
    text = ' '.join(re.split(r'\W+', text))
    text = text.replace(' um ', ' ')
    text = text.replace(' uh ', ' ')
    text = text.replace(' uh ', ' ')
    return text



personality_scores_df = pd.read_csv('youtube-personality/YouTube-Personality-Personality_impression_scores.csv', sep=' ')

transcripts = []
files = glob.glob('youtube-personality/transcripts/*')
for file in files:
    vlog_id = file.split('/')[2]
    f = open(file, 'r')
    txt = f.readlines()
    f.close()
    text = preprocess(txt)
    transcripts.append([vlog_id[:-4], text])


#transcripts[0]

#len(transcripts)

transcripts_df = pd.DataFrame(np.array(transcripts), columns = ['vlogId', 'text'])

youtube_df = personality_scores_df.set_index('vlogId').join(transcripts_df.set_index('vlogId'))


youtube_df.columns = ['sEXT', 'sNEU', 'sAGR', 'sCON', 'sOPN', 'TEXT']

